Skip to main content
POST
/
api
/
v1
/
smart-accounts
/
{smart_account_address}
/
transactions
Prepare an arbitrary transaction for a smart account
curl --request POST \
  --url https://developer-api.squads.so/api/v1/smart-accounts/{smart_account_address}/transactions \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-squads-network: <x-squads-network>' \
  --data '
{
  "transaction": "<string>",
  "transaction_signers": [
    "<string>"
  ],
  "fee_config": {
    "currency": "<string>",
    "payer_address": "<string>",
    "self_managed_fees": false
  }
}
'
import requests

url = "https://developer-api.squads.so/api/v1/smart-accounts/{smart_account_address}/transactions"

payload = {
"transaction": "<string>",
"transaction_signers": ["<string>"],
"fee_config": {
"currency": "<string>",
"payer_address": "<string>",
"self_managed_fees": False
}
}
headers = {
"x-squads-network": "<x-squads-network>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {
'x-squads-network': '<x-squads-network>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
transaction: '<string>',
transaction_signers: ['<string>'],
fee_config: {currency: '<string>', payer_address: '<string>', self_managed_fees: false}
})
};

fetch('https://developer-api.squads.so/api/v1/smart-accounts/{smart_account_address}/transactions', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "transaction": "<string>",
  "fee": {
    "amount": "<string>",
    "amount_decimal": "<string>",
    "currency": "<string>",
    "sol_equivalent": {
      "amount": "<string>",
      "amount_decimal": "<string>"
    }
  },
  "simulation_logs": [
    "<string>"
  ]
}
{
"status": 123,
"code": "<string>",
"message": "<string>",
"details": [
{
"field": "<string>",
"code": "<string>",
"message": "<string>",
"expected": "<string>",
"actual": "<string>"
}
],
"metadata": {
"status": 123,
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"resource_id": "<string>",
"useful_links": [
"<string>"
]
},
"custom": {},
"simulation_logs": [
"<string>"
]
}
{
"status": 123,
"code": "<string>",
"message": "<string>",
"details": [
{
"field": "<string>",
"code": "<string>",
"message": "<string>",
"expected": "<string>",
"actual": "<string>"
}
],
"metadata": {
"status": 123,
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"resource_id": "<string>",
"useful_links": [
"<string>"
]
},
"custom": {},
"simulation_logs": [
"<string>"
]
}
{
"status": 123,
"code": "<string>",
"message": "<string>",
"details": [
{
"field": "<string>",
"code": "<string>",
"message": "<string>",
"expected": "<string>",
"actual": "<string>"
}
],
"metadata": {
"status": 123,
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"resource_id": "<string>",
"useful_links": [
"<string>"
]
},
"custom": {},
"simulation_logs": [
"<string>"
]
}

Key Concepts

  • Transaction Signing: Only authorized signers can create transactions
  • Destination: Tokens will be sent to the specified destination address

Important Notes

  • The transaction must be valid and signed by the authorized signers

Authorizations

Authorization
string
header
required

UUID-based API key provided by Squads

Headers

x-squads-network
enum<string>
required

Specifies the network for the API request

Available options:
mainnet,
devnet

Path Parameters

smart_account_address
string
required

The address of the smart account

Query Parameters

debug
boolean

When true, includes transaction simulation logs in the response

Body

application/json
transaction
string
required

The serialized transaction to be processed

transaction_signers
string[]

List of signers for this transaction

fee_config
object

Response

Transaction prepared successfully

transaction
string

The prepared transaction ready for execution

fee
object
simulation_logs
string[]

Transaction simulation logs. Returns an empty array when debug=false or not provided.